/*
 * config.h
 *
 *  Created on: 29.06.2018
 *      Author: john
 */

#ifndef CONFIG_H_
#define CONFIG_H_

#include <stdint.h>

#define OPEN_DRAIN_OUTPUTS 0
#define INVERT_DIRECTIONSIGNALS 0
#define INVERT_ENABLESIGNALS 1
#define INVERT_STEPSIGNALS 0
#define INVERT_STOPSIGNALS 1
#define PULLDOWN_STOPSIGNALS 0
#define PULLUP_STOPSIGNALS 1
#define PULLDOWN_ERRORSIGNALS 0
#define PULLUP_ERRORSIGNALS 0
#define PULLDOWN_ENCODERSIGNALS 0
#define PULLUP_ENCODERSIGNALS 0
#define DIRECTIONSIGNALS_PORT GPIO_PORTE_BASE
#define DIRECTIONSIGNALS_PERIPH SYSCTL_PERIPH_GPIOE
#define ENABLESIGNALS_PORT GPIO_PORTL_BASE
#define ENABLESIGNALS_PERIPH SYSCTL_PERIPH_GPIOL
#define STOPSIGNALS_PORT GPIO_PORTK_BASE
#define STOPSIGNALS_PERIPH SYSCTL_PERIPH_GPIOK
#define STOPSIGNALS_PINS GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5 | GPIO_PIN_6 | GPIO_PIN_7
#define STOPSIGNALS_INTERRUPT INT_GPIOK
#define STOPSIGNALS2_PORT GPIO_PORTM_BASE
#define STOPSIGNALS2_PERIPH SYSCTL_PERIPH_GPIOM
#define STOPSIGNALS2_PINS GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2 | GPIO_PIN_3
#define STOPSIGNALS2_INTERRUPT INT_GPIOM
#define ERRORSIGNALS_PORT GPIO_PORTP_BASE
#define ERRORSIGNALS_PERIPH SYSCTL_PERIPH_GPIOP
#define ERRORSIGNALS_INTERRUPT INT_GPIOC
#define ENCODERSIGNALS_I1_PORT GPIO_PORTC_BASE
#define ENCODERSIGNALS_I1_PERIPH SYSCTL_PERIPH_GPIOC
#define ENCODERSIGNALS_I1_PINS GPIO_PIN_4 | GPIO_PIN_5 | GPIO_PIN_6 | GPIO_PIN_7
#define ENCODERSIGNALS_I1_NUMPINS 4
#define ENCODERSIGNALS_I1_FIRST_PIN 4
#define ENCODERSIGNALS_I1_INTERRUPT INT_GPIOC
#define ENCODERSIGNALS_I2_PORT GPIO_PORTB_BASE
#define ENCODERSIGNALS_I2_PERIPH SYSCTL_PERIPH_GPIOB
#define ENCODERSIGNALS_I2_PINS GPIO_PIN_2 | GPIO_PIN_3
#define ENCODERSIGNALS_I2_NUMPINS 2
#define ENCODERSIGNALS_I2_FIRST_PIN 2
#define ENCODERSIGNALS_I2_INTERRUPT INT_GPIOB
#define ENCODERSIGNALS_Q1_PORT GPIO_PORTH_BASE
#define ENCODERSIGNALS_Q1_PERIPH SYSCTL_PERIPH_GPIOH
#define ENCODERSIGNALS_Q1_PINS GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2 | GPIO_PIN_3
#define ENCODERSIGNALS_Q1_NUMPINS 4
#define ENCODERSIGNALS_Q1_FIRST_PIN 0
#define ENCODERSIGNALS_Q1_INTERRUPT INT_GPIOH
#define ENCODERSIGNALS_Q2_PORT GPIO_PORTG_BASE
#define ENCODERSIGNALS_Q2_PERIPH SYSCTL_PERIPH_GPIOG
#define ENCODERSIGNALS_Q2_PINS GPIO_PIN_0 | GPIO_PIN_1
#define ENCODERSIGNALS_Q2_NUMPINS 2
#define ENCODERSIGNALS_Q2_FIRST_PIN 0
#define ENCODERSIGNALS_Q2_INTERRUPT INT_GPIOG
//#define DEBUGSIGNALS_PORT GPIO_PORTM_BASE
//#define DEBUGSIGNALS_PERIPH SYSCTL_PERIPH_GPIOM

const uint8_t invert_stopper_directions[] = { 1, 1, 1, 0, 1, 0 };
const uint8_t invert_errors[] = { 0, 0, 0, 0, 0, 0 };
const int8_t encoder_directions[] = { 1, 1, 1, 1, 1, 1 };

#define ECHO_UART 0
#define DEBUG 0

#endif /* CONFIG_H_ */
